function onUpload() {
	try {
		if(lockMan == null) {
			lockMan = new LockManager();
			lockMan.loadLocks();
		}

		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var titleKey = "Upload Files";

		fp.init(window, titleKey, Components.interfaces.nsIFilePicker.modeOpenMultiple);

		if (fp.show() == Components.interfaces.nsIFilePicker.returnCancel)
			return;

		var it = fp.files;

		while(it.hasMoreElements()) {
			var file = it.getNext().QueryInterface(Components.interfaces.nsIFile);

			if(file.fileSize > 0)
				uploadFile(file, lockMan.getToken(gVars.curr_dir + file.leafName), false);
			else
				alert("Cannot upload " + file.leafName + ". File size = 0.\n");
		}
	}
	catch(e) {
		alert("onUpload: " + e);
	}

}

function uploadFile(file, token, last) {
	try {
		file.QueryInterface(Components.interfaces.nsILocalFile);
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		fstream.init(file, 1, 0, 0);

		var buffer = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
		buffer.init(fstream, 4096);

		var contentType = "application/octet-stream";
		try {
			contentType = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService).getTypeFromFile(file.QueryInterface(Components.interfaces.nsIFile));
		}
		catch(err) {
			contentType = "application/octet-stream";
		}

		var channel = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newChannel(gVars.base_url + gVars.curr_dir + file.leafName, "", null).QueryInterface(Components.interfaces.nsIUploadChannel);

		var listener = {

                       onStartRequest:
		                       function (req, ctx) { }
		                       ,

                       onStopRequest:
		                       function (req, ctx, status, msg) {
			                       try {
				                       populateList();

				                       req.QueryInterface(Components.interfaces.nsIHttpChannel);
				                       if(req.responseStatus === 423) {
					                       alert("Upload Failed: File is locked by another user");
				                       }
				                       else if(req.responseStatus === 412 || req.responseStatus === 207) {
					                       if(ctx === null)
						                       return;

					                       ctx.QueryInterface(Components.interfaces.nsIFile);
					                       lockMan.removeLock(gVars.curr_dir + ctx.leafName);
					                       uploadFile(ctx, null, true);
				                       }
				                       else if(req.responseStatus !== 201 && req.responseStatus !== 204)
					                       alert("Upload Failed!\n" + req.responseStatus + " " + req.responseStatusText);

			                       }
			                       catch(e) {
				                       alert("Listener OnStopRequest: " + e);
			                       }

		                       },

                       onDataAvailable:
		                       function (req, context, inputStream, offset, count) {
		                       }
		                       ,

                       QueryInterface:
		                       function(id, inst) {
			                       if (id.equals(Components.interfaces.nsIStreamListener)
			                               || id.equals(Components.interfaces.nsISupports))
				                       return this;
			                       else
				                       return null;
		                       }
		               }

		               channel.setUploadStream(buffer, contentType, -1);
		channel = channel.QueryInterface(Components.interfaces.nsIHttpChannel);

		if(token !== null)
			channel.setRequestHeader("If", "<" + gVars.base_url + gVars.curr_dir + "> (" + token + ")", false);

		channel.requestMethod = "PUT";

		if(!last)
			channel.asyncOpen(listener, file);
		else
			channel.asyncOpen(listener, null);

		var list = gBrowser.selectedBrowser.contentDocument.getElementById("fileList").wrappedJSObject;
		var row = gBrowser.selectedBrowser.contentDocument.createElement("listitem");
		var cols = [ gBrowser.selectedBrowser.contentDocument.createElement("listcell"), gBrowser.selectedBrowser.contentDocument.createElement("listcell"),
		             gBrowser.selectedBrowser.contentDocument.createElement("listcell"), gBrowser.selectedBrowser.contentDocument.createElement("listcell")];

		cols[0].setAttribute("hidden", "true");
		cols[1].setAttribute("label", file.leafName);
		cols[3].setAttribute("label", "Uploading...");

		row.appendChild(cols[0]);
		row.appendChild(cols[1]);
		row.appendChild(cols[2]);
		row.appendChild(cols[3]);

		list.appendChild(row);
	}
	catch(e) {
		alert("Upload file: " + e);
	}
}
